BuildRequires:  check
BuildRequires:  cmake28
BuildRequires:  doxygen
BuildRequires:  gcc-c++
BuildRequires:  neon-devel
BuildRequires:  sqlite-devel

Name:           ocsync
Version:	0.91.4
Release:        1.1%{?dist}
Summary:        A user level bidirectional client only file synchronizer (owncloud version)
License:        GPL-2.0+
Group:          Productivity/Networking/Other
Url:            http://www.csync.org/
Source0:        %{name}-%{version}.tar.bz2
Source1:        baselibs.conf

BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
ocsync is the ownCloud version of csync. csync is an implementation of 
a file synchronizer which provides the feature of roaming home directories 
for Linux clients.

%package -n libocsync0
Summary:        A user level bidirectional client only file synchronizer
Group:          System/Libraries

%description -n libocsync0
ocsync is a csync version which is temporarily maintained by the ownCloud
community to support the ownCloud client. csync is an implementation of a 
file synchronizer which provides the feature of roaming home directories 
for Linux clients. csync makes use of libsmbclient in Samba/Windows 
environments.

%package -n libocsync-devel
Summary:        Development files for csync
Group:          Development/Libraries/C and C++
Requires:       libocsync0 = %{version}

%description -n libocsync-devel
The libocsync-devel package contains the static libraries and header
files needed for development with csync.

%package -n libocsync-devel-doc
Summary:        Developer documentation for csync
Group:          Development/Languages/C and C++

%description -n libocsync-devel-doc
The libocsync-devel-doc package provides documentation for csync
development.

%package -n libocsync-doc
Summary:        User documentation for csync
Group:          Development/Languages/C and C++

%description -n libocsync-doc
The libocsync-doc package provides user documentation for csync.

%prep
%setup -q

%build
if test ! -e "build"; then
  %{__mkdir} build
fi
pushd build
cmake28 \
  -DCMAKE_C_FLAGS:STRING="%{optflags}" \
  -DCMAKE_CXX_FLAGS:STRING="%{optflags}" \
  -DCMAKE_SKIP_RPATH=ON \
  -DCMAKE_BUILD_TYPE=RelWithDebInfo \
  -DCMAKE_INSTALL_PREFIX=%{_prefix} \
  -DCMAKE_DOC_INSTALL_PATH=%{_docdir}/ocsync \
  -DSYSCONF_INSTALL_DIR=%{_sysconfdir} \
%if %{_lib} == lib64
  -DLIB_SUFFIX=64 \
%endif
  %{_builddir}/%{name}-%{version}
%__make %{?jobs:-j%jobs} VERBOSE=1
%__make doc
popd build

%install
pushd build
%if 0%{?suse_version}
%makeinstall
%else
make DESTDIR=%{buildroot} install
%endif
popd build

%post -n libocsync0
/sbin/ldconfig

%postun -n libocsync0
/sbin/ldconfig

%clean
%__rm -rf %{buildroot}

%files
%defattr(-,root,root)
%{_mandir}/man?/ocsync.*

%files -n libocsync0
%defattr(-,root,root)
%doc AUTHORS COPYING INSTALL README
%dir %{_sysconfdir}/ocsync
%config(noreplace) %{_sysconfdir}/ocsync/ocsync.conf
%config(noreplace) %{_sysconfdir}/ocsync/ocsync_exclude.conf
%{_libdir}/libocsync.so.*

%files -n libocsync-devel
%defattr(-,root,root)
%{_includedir}/ocsync
%{_libdir}/libocsync.so
%{_libdir}/libhttpbf.a
%{_includedir}/httpbf.h

%files -n libocsync-devel-doc
%defattr(-,root,root)
%doc build/doc/html

%files -n libocsync-doc
%defattr(-,root,root)
%{_datadir}/doc/ocsync

%changelog
* Wed Jan 15 2014 benrose@math.princeton.edu
- Update for Springdale 6.
* Thu Dec 12 2013 freitag@owncloud.com
- Update to 0.91.4, ocsync version for oCC 1.5.0
  * Fix progress bar on win32
  * Fix network rate limiting on win32
  * Do not check for etag during failing requests
  * Start quota timer only after the predecessor returned
  * Remove tmp files in case of certain download problems
  * Some valgrind fixes
  * Theming fix: button behaviour
  * Fix a case where a sync loop could happen.
  * Multi-linguar installer
  * Fix handling of quotes in etags written by older ownClouds
  * Fix errno handling in update phase
  * Make csync compile on FreeBSD
  * Minor cleanups.
  * have translatable error message for indiv. file errors.
  * Use uint64_t for inode on win32 to fix a type glitch.
  * Add test that directrories are properly moved.
  * Handle symlinks correctly.
  * Do not longer recurse into ignored directories in update
    phase.
  * Added proper symlink detection for win32 platform.
  * Close database correctly to fix a potential crash (mirall#1229)
  * Handle invalid inodes correctly.
  * Use lstat rather than stat to detect symlinks correctly.
  (core#6146)
  * fix ascii to int conversion for large numbers.
  * add support for file ids, needed to detect server side moves.
  * removed unused code, ie. database writing code that went to
    mirall.
  * add functions to query the database by fileid.
  * add functions to read fileids from PUT replies.
  * add server side move detection.
  * enhanced test scripts
  * Remove ne_sock_init and ne_sock_exit from owncloud module
    (mirall#1115)
  * Renamed 'md5' to 'etag' in code identifiers to avoid confusion.
  * add new state EVAL_RENAME
  * link the owncloud module directly rather than dl-loading it.
  * add a content type header 'application/octet-stream' to PUTs.
  * remove -gzip from etag header if its there. (mirall#1195)
  * Many minor fixes, refactorings and improvements.
* Wed Dec 11 2013 freitag@owncloud.com
- Update to version 0.91.3 for oCC 1.5.0rc1
* Tue Dec 10 2013 freitag@owncloud.com
- Update to version 0.91.2 for oCC 1.5.0beta3
* Tue Dec  3 2013 freitag@owncloud.com
- Update to version 0.91.1 for oCC 1.5.0beta2
* Thu Nov 28 2013 freitag@owncloud.com
- Update to version 0.91.0 for oCC 1.5.0beta1, incl. updates of the
  package building files.
* Thu Nov 28 2013 freitag@owncloud.com
- Update to ocsync 0.91.0, ocsync version for oCC 1.5.0beta1
* Fri Nov 15 2013 freitag@owncloud.com
- Fix filelist: remove libocsync-0 directory.
* Wed Nov 13 2013 freitag@owncloud.com
- Install  httpbf header file in debian builds.
* Wed Nov 13 2013 freitag@owncloud.com
- Fix deb version numbers.
* Wed Nov 13 2013 freitag@owncloud.com
- Fixed nightly builds:
  * Added httpbf header to devel pack
  * Added httpbf lib to devel pack
  * Added doc install dir
* Tue Nov 12 2013 freitag@owncloud.com
- package libhttpbf.a to the devel package
* Tue Nov 12 2013 freitag@owncloud.com
- remove unused patch.
* Tue Nov 12 2013 freitag@owncloud.com
- Removed not longer supported plugins, we only build owncloud.
* Wed Oct 30 2013 freitag@owncloud.com
- Removed binary ocsync from debian build.
* Wed Oct 30 2013 freitag@owncloud.com
- Removed binary ocsync from spec file.
* Tue Oct  1 2013 freitag@owncloud.com
- Remove iniparser patch for fedora system.
* Mon Sep 30 2013 freitag@owncloud.com
- Fix httpbf library name
* Fri May 10 2013 danimo@owncloud.com
- Add httpbflib to list of installed files
* Wed Apr 17 2013 freitag@owncloud.com
- Fixed patch command for Fedora and CentOS
* Wed Apr 17 2013 freitag@owncloud.com
- fix the remove_signal patch for Fedora based systems.
* Wed Apr 17 2013 freitag@owncloud.com
- dont build the smb module.
* Thu Apr 11 2013 jenkins@owncloud.org
- Update to nightly build 0.70.6
* Thu Apr 11 2013 jenkins@owncloud.org
- Update to nightly build 0.70.6
* Thu Apr 11 2013 jenkins@owncloud.org
- Update to nightly build 0.70.6
* Thu Apr 11 2013 jenkins@owncloud.org
- Update to nightly build 0.70.6
* Wed Apr 10 2013 jenkins@owncloud.org
  Update to nightly build 0.70.6
* Thu Feb 21 2013 freitag@owncloud.com
- Adopted patch required for iniparser on Fedora platforms.
* Wed Feb 20 2013 freitag@owncloud.com
- copy from :devel to :devel:daily.
* Thu Jan 24 2013 freitag@owncloud.com
- Update to 0.70.3, ocsync version for oCC 1.2.0
  * [Platform] Improved module parameter system.
  * [Platform] New logging framework. Dropped log4c dependency.
  * [Platform] New API to provide sync progress information.
  * [Fixes] More efficiency for the ownCloud plugin through less HTTP requests to
    the server.
  * [Fixes] ownCloud plugin: Improved upload performance.
  * [Fixes] Improved error reporting to mirall.
  * [Fixes] ownCloud plugin: Improved interpretation of HTTP error codes.
  * [Fixes] ownCloud plugin: Do not abort on errors with individual files any
    more.
  * [Fixes] ownCloud plugin: Use renamed session cookie correctly.
  * [Fixes] Lots of other minor fixes.
  * [MacOSX] Use libneon with proper big file support.
  * [Win32] Use libneon with openSSL support now.
* Thu Jan 17 2013 freitag@owncloud.com
- Update to 0.70.1, ocsync version for oCC 1.2.0 beta2
* Fri Dec 21 2012 freitag@owncloud.com
- Update to first beta version of the 1.2.0 release.
* Thu Nov 22 2012 freitag@owncloud.com
- Update to v0.60.2, needed for ownCloud client 1.1.2
  * Migration to cross platform testing system cmocka.
  * Fixed variuos minor things incl. potential mem leaks.
  * Clang fixes.
  * Moved journal database to sync directory.
  * Fixed more csync->ocsync renaming issues.
  * Fixed statedb query below path.
  * Fixed win32 Daylight Saving Time issues.
  * Allow static linking with iniparser and sqlite.
  * Win32: Fix CreateHandle function in local stat.
  * Win32: More wide char fixes.
  * Added version table to journal database.
  * Fixes for HTTP reply computation.
  * Stricter error checks on PROPFIND results.
  * Workaround for DST influenced times from previous versions.
  * Detect looping in mkdirs to fix sharing.
* Thu Oct 18 2012 danimo@owncloud.com 
- Update to v0.60.1, needed for ownCloud client 1.1.1
  * Fix improper memory cleanup which could cause memory leaks
    and crashes
  * Fix memory leak
  * Allow single quote (') in file names
  * Remove stray temporary files
* Wed Oct 10 2012 freitag@owncloud.com
- Update to v0.60.0, needed for ownCloud client 1.1.0
  * simplification of pac based proxy support.
  * Renamed ownCloud version of csync to ocsync for ownCloud.
  * Migration paths for csync database and config.
  * Fixed that exclude patterns are also tested on files basenames.
  * Fixed return type for query function if no database exists.
  * minor code fixes
  * Fixed crash by removing a bogus free.
  * More useful logging.
  * ownCloud: Maintain the http session by handling the HTTP Cookie.
  * Fixed strncpy handling (mkdir on windows problem).
  * extend database with columns uniq id and type.
  * Use server maintained uniq IDs for update detection instead of
    mtimes.
  * Maintain uniq IDs in local database
  * Handle change propagation through the file tree locally and remote.
  * Added module to build a file tree from the local database (dbtree.c)
  * Added methods to query IDs from the server and maintain it locally.
* Fri Oct  5 2012 freitag@owncloud.com
- Update to v0.50.11 Beta
  from now on this package is called ocsync to not confuse with the
  upstream csync.
* Thu Sep 20 2012 freitag@owncloud.com
- Update to v0.50.10 Beta
* Fri Aug 31 2012 msrex@owncloud.com
- Update to v0.50.9 Beta
* Thu Aug 30 2012 msrex@owncloud.com
- Update to v0.50.8:
  * Inode equivalent support for Win32 platforms to support rename
  * ownCloud supports propagates renames from local to webdav MOVE
  * ownCloud module works with proxy, settings from mirall.
  * improved CMake modules (openSSL)
  * Fixed namespace for lastmodified propset.
  * Added cmocka based tests for ownCloud module.
  * Added a config_test.h config header file.
  * Fix link handling: Ignore symlinks.
  * Modules can now report their capabilities to csync core.
  * A lot of minor fixes and improvements.
* Fri Jun 22 2012 freitag@owncloud.com
- update to version 0.50.7 (released 2012-06-19)
  * Added ability to log to a callback, ie. let the app
    catch the log output
  * Added push to remote without pushing to temp file first.
  * Fixed file copy function to use wide character (win32).
  * Fixed loading of statedb if user has special char (win32).
* Wed May 16 2012 freitag@owncloud.com
- update to final 0.50.6
  * Directories with 'strange' characters broke sync. (oC bug #613)
  * Special characters in Windows did not sync correctly. (oC bug #478)
  * Make neon redirecting
  * Switch logging off on Apple to not fill the syslog. (oC bug #622)
* Fri May 11 2012 freitag@owncloud.com
- update to beta of 0.50.6, next release.
* Fri Apr 20 2012 msrex@owncloud.com
- reformat debian packaging files
* Thu Apr 19 2012 msrex@owncloud.com
- clean-up convoluted requires
* Thu Apr 19 2012 msrex@owncloud.com
- also disable sftp module on SLES
* Wed Apr 18 2012 msrex@owncloud.com
- re-enable sftp-module on fedora
* Wed Apr 18 2012 msrex@owncloud.com
- disable sftp-module on RHEL and CentOS
* Wed Apr 18 2012 msrex@owncloud.com
- fix dependencies for RHEL / CentOS
* Wed Apr 18 2012 msrex@owncloud.com
- changes to debian packaging
* Wed Apr 18 2012 freitag@opensuse.org
- version 0.50.5 (released 2012-04-18)
  required for owncloud client 1.0.1
  * removed argp lib dependency
  * simplified and fixed CMake files
  * MacOS porting efforts
  * more granular error reports, thread save
* Mon Apr  2 2012 freitag@opensuse.org
- Update to upstream version 0.50.4 with more fine tunes and fixes.
* Mon Apr  2 2012 freitag@opensuse.org
- Disable sftp for SLES as the package is too old.
* Mon Mar 26 2012 freitag@opensuse.org
- Update to internal beta version 0.50.3 with more bugfixes.
* Tue Mar 13 2012 freitag@opensuse.org
- Update to internal beta version 0.50.2 with more bugfixes.
* Fri Mar  2 2012 freitag@opensuse.org
- Update to internal beta version 0.50.1
* Wed Feb 22 2012 freitag@opensuse.org
- Update to upstream beta version 0.49.9:
  * Added owncloud module.
  * Added backup reconciler.
  * Fixed serveral bugs.
* Tue Feb 16 2010 anschneider@exsuse.de
- Build always with libssh support.
* Mon Feb 15 2010 anschneider@exsuse.de
- Update to version 0.44.0.
  * Migrated sftp module to libssh 0.4.
  * Added more cache entries to the default config.
  * Added missing requirements.
  * Fixed build warnings.
  * Fixed some memory leaks using sftp attributes.
  * Some code cleanups.
* Sun Jan 31 2010 jengelh@medozas.de
- Package baselibs.conf
* Mon May 25 2009 anschneider@exsuse.de
- Update to version 0.43.0.
  * Added SFTP support with libssh 0.3.
  * Added possibility to pass userdata to the auth function.
  * Added a better version function.
  * Fixed CMake build.
  * Fixed CMake find modules.
  * Fixed some flaws in cstd functions.
  * Documented all public functions.
* Fri Apr 17 2009 anschneider@exsuse.de
- Fix Fedora build.
- Change the way how to set CFLAGS.
* Thu Feb 26 2009 anschneider@suse.de
- Update to version 0.42.0
  * Small fix in the userguide.
* Fri Jan 23 2009 anschneider@suse.de
- Update to version 0.42.0 rc3
  * Added checks for unix extensions.
  * Added more documentation to the userguide.
  * Fixed loading of plugins.
  * Fixed call for deletion functions.
  * Normalize the path to <hostname>/<path> for the statedb filename.
  * More change name of client options to be more descriptive.
- Add recommends for the plugins.
* Thu Jan  8 2009 anschneider@suse.de
- Fix loading of plugins.
- Add requires to the plugins.
* Thu Jan  8 2009 anschneider@suse.de
- Update to version 0.42.0 rc2
  * Reduced syscalls
  * Fixed a bug in the state database
  * Fixed libsmbclient support
  * Completed userguide
* Fri Dec  5 2008 anschneider@suse.de
- Update to version 0.42.0 rc1
  libcsync:
  * Reduced calls of syscall functions.
  * Added own function to create a temporary filename.
  * Fixed libsmbclient 3.0.x support.
* Wed Sep 10 2008 anschneider@suse.de
- Created a subpackage for each plugin and for the user guide
- Update to version 0.42.0 beta1
  libcsync:
  * Added a sftp module using libssh
  * Added user guide (just a start)
  * Added testcase for update detection
  * Added a function to parse an uri to cstdlib
  * Updated the manpage
  * Fixed some segfaults in cstdlib
  * Fixed some memory leaks
  csync:
  * Improved the auth callback
* Thu Jul  3 2008 anschneider@suse.de
- Set the right group for the different packages
* Wed Jul  2 2008 anschneider@suse.de
- Update to version 0.42.0 alpha4
  libcsync:
  * Added the possibility to run csync completely without a journal
  * Improved chmod calls during propagation. Most of the time we use the
    default mode and don't need to call chmod.
  * Improved the exclude list handling in the file tree walker. This
    increased the speed of the update detection.
  * Fixed csync on PPC
  * Fixed serveral small bugs
  csync:
  * Added commandline option to run csync completely without a journal
* Fri Jun 27 2008 anschneider@suse.de
- Fixed csync on PPC
* Wed Jun 25 2008 anschneider@suse.de
- Update to version 0.42.0 alpha3
  libcsync:
  * Added a tree merger to write a complete journal
  * Added support to run csync without a journal
  * Fixed kerberos support in csync_smb module
  * Fixed closing of files after the copy
  * Fixed update detection to detect special files (fifo, pipes,
    char devices, ..)
  * Fixed O_NOATIME flag on open() if we don't have the permission
  csync:
  * Add a variable to run csync completely without a journal
* Tue Jun 17 2008 anschneider@suse.de
- Fix update detection for special files (fifo, char device, ..)
- Fix propagation for files the user doesn't own
* Mon Jun 16 2008 anschneider@suse.de
- Update to version 0.41.92 (0.42.0 alpha2)
  libcsync:
  * Peformance improvements
  * Add more directories to the standard exclude file
  * Bugfixes
* Wed Jun  4 2008 anschneider@suse.de
- Build for redhat based distributions
* Mon Jun  2 2008 anschneider@suse.de
- Update to version 0.41.91 (0.42.0 alpha1)
* Mon May  5 2008 anschneider@suse.de
- Initial verison 0.41.90
